<?php

namespace Modules\Lpj\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Modules\Lpj\Models\Regions;
use Modules\Lpj\Http\Requests\RegionRequest;
use Maatwebsite\Excel\Facades\Excel;
use Modules\Lpj\Exports\RegionExport;


class RegionController extends Controller
{
    public $user;
    public function index()
    {
        return view('lpj::region.index');
    }
    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('lpj::region.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(RegionRequest $request)
    {
        $validate = $request->validated();

            if ($validate) {
                try {
                    // Save to database
                    Regions::create($validate);
                    return redirect()
                        ->route('basicdata.region.index')
                        ->with('success', 'region created successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.region.create')
                        ->with('error', 'Failed to create region');
                }
            }
    }


    public function edit($id)
    {
        $region = Regions::find($id);
        return view('lpj::region.create', compact('region'));

    }

    /**
     * Update the specified resource in storage.
     */
    public function update(RegionRequest $request, $id)
    {
        $validate = $request->validated();

            if ($validate) {
                try {
                    // Update in database
                    $region = Regions::find($id);
                    $region->update($validate);
                    return redirect()
                        ->route('basicdata.region.index')
                        ->with('success', 'Region updated successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.region.edit', $id)
                        ->with('error', 'Failed to update region');
                }
            }
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($id)
    {
        try {
            // Delete from database
            $region = Regions::find($id);
            $region->delete();

            echo json_encode(['success' => true, 'message' => 'Region deleted successfully']);
        } catch (Exception $e) {
            echo json_encode(['success' => false, 'message' => 'Failed to delete region']);
        }
    }

    public function dataForDatatables(Request $request)
    {


        if (is_null($this->user) || !$this->user->can('region.view')) {
            //abort(403, 'Sorry! You are not allowed to view users.');
        }

        $query = Regions::query();

        if ($request->has('search') && !empty($request->get('search'))) {
            $search = $request->get('search');
            $query->where(function ($q) use ($search) {
                $q->where('code', 'LIKE', "%$search%");
                $q->orWhere('name', 'LIKE', "%$search%");
            });
        }

        if($request->has('sortOrder') && !empty($request->get('sortOrder'))){
            $order  = $request->get('sortOrder');
            $column = $request->get('sortField');
            $query->orderBy($column, $order);
        }

        $totalRecords = $query->count();

         // Apply pagination if provided
         if ($request->has('page') && $request->has('size')) {
            $page   = $request->get('page');
            $size   = $request->get('size');
            $offset = ($page - 1) * $size; // Calculate the offset

            $query->skip($offset)->take($size);
        }

        // Get the filtered count of records
        $filteredRecords = $query->count();

        // Get the data for the current page
        $data = $query->get();

        // Calculate the page count
        $pageCount = ceil($totalRecords / $request->get('size'));

        // Calculate the current page number
        $currentPage = 0 + 1;

        // dump($data);

        // Return the response data as a JSON object
        return response()->json([
            'draw'            => $request->get('draw'),
            'recordsTotal'    => $totalRecords,
            'recordsFiltered' => $filteredRecords,
            'pageCount'       => $pageCount,
            'page'            => $currentPage,
            'totalCount'      => $totalRecords,
            'data'            => $data
        ]);
    }

    public function export()
        {
            return Excel::download(new RegionExport, 'region.xlsx');
        }
}
